﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace OnlineVideos.Sites
{
    public class VideoMediasetUtil : GenericSiteUtil
    {
        string baseUrl = @"http://www.video.mediaset.it/";

        public override List<VideoInfo> getVideoList(Category category)
        {

            string strSiteSource = GetWebData(((RssLink)category).Url);
            
            if (strSiteSource.Contains("<ul id=\"menu-video\">"))
            {
                List<VideoInfo> result = new List<VideoInfo>();
            
                MatchCollection ids = Regex.Matches(strSiteSource, "<div\\sclass=\"boxvideo\\svideo-(?<Description>[^\\s]*)\\stab\"\\sid=\"(?<VideoUrl>[^\"]*)\">", RegexOptions.IgnoreCase | RegexOptions.Singleline); //Regex.Match(strSiteSource, "<div\\sclass=\"boxvideo\\svideo-full\\stab\"\\sid=\"(?<ID>[^\"]*)\">", RegexOptions.IgnoreCase | RegexOptions.Singleline);
              
                foreach (Match item in ids)
                {
                    string createUrl = string.Concat(baseUrl, item.Groups["VideoUrl"].Value.Replace("|", "/"), ".shtml?page={0}&dim=2");
                    int page = 0;
                    string tempVideoSource = null;
                    RssLink rs = new RssLink();
                    
                    do
                    {
                        page++;
                        tempVideoSource = GetWebData(string.Format(createUrl, page)).Trim();
                        string tRegex = "<a\\stitle=\"(?<Title>[^\"]*)\"\\shref=\"(?<VideoUrl>[^\"]*)\"\\srel=\"nofollow\"><img\\salt=\"[^\"]*\"\\ssrc=\"(?<ImageUrl>[^\"]*)\"></a>\\s*</div>\\s*<p\\sclass=\"[^\"]*\">\\s*<a\\stitle=\"[^\"]*\"\\shref=\"[^\"]*\"\\srel=\"[^\"]*\"\\sonclick=\"[^\"]*\">[^\"]*</a>\\s*</p>\\s*<h2>\\s*<a\\stitle=\"[^\"]*\"\\shref=\"[^\"]*\"\\srel=\"[^\"]*\">[^\"]*</a>\\s*</h2>\\s*<p\\sclass=\"desc\">(?<Description>[^<]*)</p>\\s*<div\\sclass=\"infovideo\">\\s*<p\\sclass=\"tipo\">\\s*<span>[^\"]*</span>\\s*</p>\\s*<p\\sclass=\"intv\">[^\"]*<span>[^\"]*</span>\\s*</p>\\s*<p\\sclass=\"durata\">[^\"]*\\s<span>(?<Duration>[^<]*)</span>\\s*</p>";
                        MatchCollection vids = Regex.Matches(tempVideoSource,tRegex,RegexOptions.IgnoreCase | RegexOptions.Singleline);
                        foreach (Match v in vids)
                        {
                            VideoInfo i = new VideoInfo();
                            i.Title = string.Concat(item.Groups["Description"].Value,";",v.Groups["Title"].Value);
                            i.ImageUrl = v.Groups["ImageUrl"].Value;
                            i.Description = v.Groups["Description"].Value;
                            i.VideoUrl = v.Groups["VideoUrl"].Value;
                            result.Add(i);
                        }
                    } while (!string.IsNullOrEmpty(tempVideoSource));
                }
                return result;
            }
            return base.getVideoList(category);
        }

        public override int DiscoverDynamicCategories()
        {
            Settings.DynamicCategoriesDiscovered = true;

            if (Settings.Categories.Count > 0 && regEx_dynamicSubCategories != null)
            {
                for (int i = 0; i < Settings.Categories.Count; i++)
                    if (!(Settings.Categories[i] is Group))
                    {
                        string strSiteSource = GetWebData(((RssLink)Settings.Categories[i]).Url);
                        if (strSiteSource.Contains("<select class=\"dk\" name=\"listadd\" tabindex=\"1\">"))
                        {
                            Settings.Categories[i].HasSubCategories = true;
                        }
                    }
            }

            return 0;
        }        

        
    }
}
